﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Private MyMap As Map
	Private ResultMap As Map
	Private MyPanel As Panel
	Private MyScroll As ScrollView
	Private IndexMap As Int
	Private MyTitolo As Label
	Private BPrev As Button
	Private EventName As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Event As String)
	Dim Ac As Activity = getCurrentActivity
	
	EventName=Event & "_"
	ResultMap.Initialize

	IndexMap=0
	
	MyPanel.Initialize("")
	MyPanel.Color=Colors.ARGB(50,0,0,0)
	MyScroll.Initialize(1000dip)
	Ac.AddView(MyPanel,0,0,100%x,100%y)
	MyTitolo=AddTitle("")
	MyPanel.AddView(MyTitolo,0,0,100%x,50dip)
	MyPanel.AddView(MyScroll,0dip,50dip,100%x,100%y-100dip)
	MyPanel.Color=Colors.LightGray
	
	BPrev.Initialize("BPrev")
	BPrev.Color=Colors.Black
	BPrev.TextColor=Colors.White
	BPrev.Text="<"
	MyPanel.AddView(BPrev,0,100%y-50dip,50dip,50dip)

	MyMap.Initialize
End Sub

Sub View As View
	Return MyPanel
End Sub

#Region PrivateFunction

Private Sub getCurrentActivity As Activity
	Dim r As Reflector
	r.Target = r.GetActivityBA
	Return r.GetField("vg")
End Sub

Private Sub AddTitle(Titolo As String) As Label
	Dim L As Label
	
	L.Initialize("")
	L.Color=Colors.White
	L.TextColor=Colors.Black
	L.TextSize=20
	L.Gravity=Gravity.CENTER
	L.Text=Titolo
	
	Return l
End Sub

Private Sub AddButton(Risposta As String,Index As Int) As Button
	Dim B As Button
	
	B.Initialize("Button")
	B.Color=Colors.Blue
	B.TextColor=Colors.White
	b.TextSize=14
	b.Gravity=Gravity.CENTER
	B.Typeface=Typeface.DEFAULT_BOLD
	b.Text=Risposta
	B.Tag=Index
	
	Return b
End Sub

Private Sub Button_Click
	Dim B As Button = Sender
	Dim Index As Int = B.Tag
	
	ResultMap.Put(ResultMap.GetKeyAt(Index),B.Text)
	Index=Index+1
	If Index<MyMap.Size Then 
		IndexMap=Index
		Vedi(IndexMap)
		ToastMessageShow(B.Text,False)
	Else
		MyPanel.Visible=False
		If SubExists(Main,EventName & "Result") Then CallSub2(Main,EventName & "Result",ResultMap)
	End If
End Sub

private Sub Vedi(IndexMenu As Int)
	Dim Altezza As Int = 40dip
	Dim Y As Int = 0
	Dim L As List = MyMap.GetValueAt(IndexMenu)
	
	MyScroll.Panel.Height=0
	If L.IsInitialized Then 
		MyTitolo.Text=MyMap.GetKeyAt(IndexMenu)
		MyScroll.Panel.Color=Colors.Gray
		MyScroll.Panel.RemoveAllViews
		For i=0 To L.Size-1
			MyScroll.Panel.AddView(AddButton(L.Get(i),IndexMenu),10dip,Y,MyScroll.Width-20dip,Altezza-1dip)
			
			Y=Y+Altezza
		Next
		MyScroll.Panel.Height=y
		End If
End Sub

Sub BPrev_Click
	If IndexMap>0 Then 
		IndexMap=IndexMap-1
		Vedi(IndexMap)
	End If
End Sub

#End Region

#Region PubblicFunction

Sub GetResponse(TitoloMenu As String) As String
	Dim S As String = ResultMap.Get(TitoloMenu)
	Return s
End Sub

Sub AddList(MenuName As String, Voci() As String)
	Dim L As List
	
	L.Initialize
	For i=0 To Voci.Length-1
		L.Add(Voci(i))
	Next
	MyMap.Put(MenuName,L)
	' Azzera i risultati
	For i=0 To MyMap.Size-1
		ResultMap.Put(MyMap.GetKeyAt(i),"")
	Next
	
	Vedi(IndexMap)
End Sub

Sub Clear
	MyPanel.Visible=True
	MyMap.Initialize
	ResultMap.Initialize
	MyScroll.Panel.RemoveAllViews
End Sub

Sub RestartMenu
	IndexMap=0
	MyPanel.Visible=true
	Vedi(0)
End Sub

#End Region

